package de.uni_marburg.powersort.data;

import java.util.Arrays;

public abstract class  ObjectSupplier {
    private final Object[] readOnly;

    ObjectSupplier(Object[] readOnly) {
        this.readOnly = readOnly;
    }

    /**
     * Descriptive title for the array of objects represented by this object.
     */
    public abstract String title();

    /**
     * @return A fresh copy of the array of objects represented by this object.
     */
    public Object[] getCopy(){
        return Arrays.copyOf(readOnly, readOnly.length);
    }
}
